<i18n>
  {
    "fr": {
      "label": "Ajouter une tutelle"
    },
    "en": {
      "label": "Add an administration"
    }
  }
  </i18n>

<template>
  <b-taginput
    field="name"
    name="administrations"
    icon="caret-right"
    :data="filteredAdministrations"
    :allow-new="true"
    v-validate="'required'"
    rounded
    v-model="buffer"
    :placeholder="$t('label')"
    :open-on-focus="true"
    @typing="getFilteredAdministrations"
    @input="$emit('input', buffer)"
    autocomplete
  >
    <template slot-scope="props">
      {{props.option.name}}
    </template>
  </b-taginput>
</template>

<script>
export default {
  name: 'AdministrationInput',
  inject: ['$validator'],
  props: {
    value: Array
  },
  data () {
    return {
      filteredAdministrations: this.allAdministrations,
      buffer: Object.assign([], this.value)
    }
  },
  computed: {
    allAdministrations: function () {
      return this.$store.getters['api/administrations']
    }
  },
  watch: {
    value: {
      handler () {
        this.buffer = Object.assign([], this.value)
      },
      deep: true
    }
  },
  methods: {
    getFilteredAdministrations (text) {
      this.filteredAdministrations = this.allAdministrations.filter((option) => {
        return option.name
          .toString()
          .toLowerCase()
          .indexOf(text.toLowerCase()) >= 0
      })
    }
  },
  created () {
    this.$store.dispatch('api/getAdministrations')
  }
}
</script>
